//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  Blue
#property indicator_color2  Red
#property indicator_color3  Blue
#property indicator_color4  Red
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  3
#property indicator_width4  3

//
//
//
//
//

extern int    RsiPeriod       = 14;
extern int    Price           = 0;
extern double levelOb         = 70.0;
extern double levelOs         = 30.0;
extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav";

double rsihu[];
double rsihd[];
double rsihbu[];
double rsihbd[];
double rsi[];
double trend[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,rsihu);  SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,rsihd);  SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,rsihbu); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,rsihbd); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,rsi);
   SetIndexBuffer(5,trend);
   return(0);
}
int deinit() { return(0); }

//
//
//
//
//

int start()
{
   int counted_bars  = IndicatorCounted(); 
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
       int limit = MathMin(Bars - counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(int i = limit; i >= 0; i--)
   {
      rsi[i]   = iRsi(iMA(NULL,0,1,0,MODE_SMA,Price,i),RsiPeriod,i);
      trend[i] = 0;
         if (rsi[i]>levelOs && rsi[i+1]<=levelOs) trend[i] =  1;
         if (rsi[i]<levelOb && rsi[i+1]>=levelOb) trend[i] = -1;
         
         //
         //
         //
         //
         //
      
         rsihu[i]  = EMPTY_VALUE;
         rsihd[i]  = EMPTY_VALUE;
         rsihbu[i] = EMPTY_VALUE;
         rsihbd[i] = EMPTY_VALUE;
        // if (trend[i] !=trend[i+1])
        // {
            if (trend[i]== 1)
            {
               rsihu[i]  = High[i];
               rsihd[i]  = Low[i];
               rsihbu[i] = MathMax(Open[i],Close[i]);
               rsihbd[i] = MathMin(Open[i],Close[i]);
            }               
            if (trend[i]== -1)
            {
               rsihu[i]  = Low[i];
               rsihd[i]  = High[i];
               rsihbu[i] = MathMin(Open[i],Close[i]);
               rsihbd[i] = MathMax(Open[i],Close[i]);
            } 
            
         //}        
      }  
      
      //
      //
      //
      //
      //
      
      if (alertsOn)
      {
        if (alertsOnCurrent)
             int whichBar = 0;
        else     whichBar = 1;
        if (trend[whichBar] != trend[whichBar+1])
        if (trend[whichBar] == 1)
              doAlert("up candle");
        else  doAlert("down candle");       
     }
return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//
//

double workRsi[][3];
#define _price  0
#define _change 1
#define _changa 2

//
//
//
//

double iRsi(double price, double period, int shift, int forz=0)
{
   if (ArrayRange(workRsi,0)!=Bars) ArrayResize(workRsi,Bars);
      int    z     = forz*3; 
      int    i     = Bars-shift-1;
      double alpha = 1.0/period; 

   //
   //
   //
   //
   //
   
   workRsi[i][_price+z] = price;
   if (i<period)
      {
         int k; double sum = 0; for (k=0; k<period && (i-k-1)>=0; k++) sum += MathAbs(workRsi[i-k][_price+z]-workRsi[i-k-1][_price+z]);
            workRsi[i][_change+z] = (workRsi[i][_price+z]-workRsi[0][_price+z])/MathMax(k,1);
            workRsi[i][_changa+z] =                                         sum/MathMax(k,1);
      }
   else
      {
         double change = workRsi[i][_price+z]-workRsi[i-1][_price+z];
                         workRsi[i][_change+z] = workRsi[i-1][_change+z] + alpha*(        change  - workRsi[i-1][_change+z]);
                         workRsi[i][_changa+z] = workRsi[i-1][_changa+z] + alpha*(MathAbs(change) - workRsi[i-1][_changa+z]);
      }
   if (workRsi[i][_changa+z] != 0)
         return(50.0*(workRsi[i][_change+z]/workRsi[i][_changa+z]+1));
   else  return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Rsi candles ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Rsi candles "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}
      